from orchestrator.domain.base import SubscriptionModel
from orchestrator.types import SubscriptionLifecycle, strEnum

from gso.products.product_blocks.iptrunk \
    import IptrunkBlock, IptrunkBlockInactive, IptrunkBlockProvisioning


class IptrunkType(strEnum):
    Dark_fiber = "Dark_fiber"
    Leased = "Leased"


class IptrunkInactive(SubscriptionModel, is_base=True):
    iptrunk_type: IptrunkType
    iptrunk: IptrunkBlockInactive


class IptrunkProvisioning(IptrunkInactive,
                         lifecycle=[SubscriptionLifecycle.PROVISIONING]):
    iptrunk_type: IptrunkType
    iptrunk: IptrunkBlockProvisioning


class Iptrunk(IptrunkProvisioning, lifecycle=[SubscriptionLifecycle.ACTIVE]):
    iptrunk_type: IptrunkType
    iptrunk: IptrunkBlock
